
    #                       
    #       +------------------------------------------------------+
    #       |  Christian 'chris' Hopf <mail@dev.christianhopf.de> |
    #       +------------------------------------------------------+
    #                                                                     
    #          
    #           developer:  Christian 'chris' Hopf
    #           system:     eggdrop v1.6.18+RC1 - tcl/tk v.8.5a2
    #           product:    QuakeNet Channel Controller (http://www.christianhopf.de/?page_id=61)
    #           version:    1.0.0.0
    #                         
    #           contact:    mail@dev.christianhopf.de
    #           irc:        #chris at QuakeNet
    #           web:        www.christianhopf.de
    #


    # QuakeNet Channel Controller 1.0.0.0
    # copyright (c) 2006 Christian 'chris' Hopf

    # This program is free software; you can redistribute it and/or modify
    # it under the terms of the GNU General Public License as published by
    # the Free Software Foundation; either version 2 of the License, or
    # (at your option) any later version.

    # This program is distributed in the hope that it will be useful,
    # but WITHOUT ANY WARRANTY; without even the implied warranty of
    # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    # GNU General Public License for more details.

    # You should have received a copy of the GNU General Public License
    # along with this program; if not, write to the Free Software
    # Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    #
    #
    # changelog
    #
    #   27.07.2006 - 1.0.0.0 release
    #
    #
    #   for more questions please ask via eMail or IRC (#chris at QuakeNet)
    #
    
    
    # --- namespace ::qnetcontrol
    namespace eval ::qnetcontrol {
      
      # --- namespace variable   
      namespace eval variable {         
        
        # string variable trigger {default}
        variable trigger "!qnet"
        
        # string variable keyword {default}
        variable keyword "qnet"
        
        # string variable flag
        variable flag "nm|nm"
        
        # integer variable botnick
        # 0 = botnick keyword command text
        # 1 = botnick command text
        variable botnick 1
        
        # integer variable update {default}
        # 0 = no notify, if an update is available
        # 1 = notify, if an update is available (only for bot owners)
        variable update 1

        # {{{ NOW don't change anything, if you aren't 100% sure what you are doing }}}
        # {{{ NOW don't change anything, if you aren't 100% sure what you are doing }}}
        # {{{ NOW don't change anything, if you aren't 100% sure what you are doing }}}
        # {{{ NOW don't change anything, if you aren't 100% sure what you are doing }}}
        
        # string variable up2date
        variable up2date "http://stuff.christianhopf.de/script/index.php?script=qnetcontrol"
        
        # string variable regexp (for trigger)
        variable regexp {[!|\?|.|-||\%|&|\*|:|\+|$|A-Z|a-z]}
        
        # string variable qnetcontrolregexp
        variable qnetcontrolregexp {[!|\?|.|-||\%|&|\*|:|\+|$|A-Z|a-z]}
        
        # string variable author
        variable author "2006 Christian 'chris' Hopf \002(\002#chris - www.christianhopf.de\002)\002"
        
        # string variable version
        variable version "v1.0.0.0"
        
        package require http
        
      }
      
      # binds
      bind PUBM -|- {*} ::qnetcontrol::pubm
      bind MSGM -|- {*} ::qnetcontrol::msgm
      bind FLUD -|- {msg} ::qnetcontrol::flood
      
      foreach time {12 15 19 00} {
        bind TIME -|- "00 $time *" ::qnetcontrol::up2date
      }    
      
      # - void proc flood {bind FLUD}
      proc flood { nickname hostname handle type channel } {
          if { ([string equal -nocase $nickname "Q"] && [string equal -nocase $hostname "TheQBot@CServe.quakenet.org"]) || ([string equal -nocase $nickname "L"] && [string equal -nocase $hostname "TheLBot@lightweight.quakenet.org"]) } {
            return 1
          }
          
          return 0
      }
      
      # - void proc pubm {bind PUBM}
      proc pubm { nickname hostname handle channel arguments } {
          ::qnetcontrol::parse $nickname $hostname $handle $arguments $channel "pubm"
      }
      
      # - void proc msgm {bind MSGM}
      proc msgm { nickname hostname handle arguments } {
          ::qnetcontrol::parse $nickname $hostname $handle $arguments [lindex [split $arguments] 2] "msgm"
      }
      
      # - void proc up2date {bind TIME}
      proc up2date { {args ""} } {
          regexp -- {(.+) \| (.+) \| (.+) \| (.+) \| (.+)} [::qnetcontrol::misc::up2date] -> id name link version help
          
          set publicversion [string map {"." ""} $version]
          set scriptversion [string map {"v" "" "." ""} $::qnetcontrol::variable::version]
          
          if { $publicversion > $scriptversion } {
            foreach owner [userlist n] {
              if { [::qnetcontrol::misc::update $owner] && [hand2nick $owner] != "" } {
                putserv "NOTICE [hand2nick $owner] :\002(\002\037qnetcontrol\037\002)\002 a new version of your qnetcontrol is available (v${version}). more infos at $help"
              }
            }
          }
      }
      
      # - void proc parse
      proc parse { nickname hostname handle arguments channel mode} {
          global botnick rchannel lastparse lastchannel lastnickname service
          
          set utrigger [::qnetcontrol::misc::trigger $handle]
          set ukeyword [::qnetcontrol::misc::keyword $handle]
          set rchannel $channel
  
          if { $mode == "pubm" } {
  
            if { $::qnetcontrol::variable::botnick == 1 && [string equal -nocase $botnick [lindex [split $arguments] 0]] } {
              set command [string tolower [lindex [split $arguments] 1]]
              set arguments [join [lrange [split $arguments] 2 end]]
              set lastparse "$botnick $command"
            } elseif { $::qnetcontrol::variable::botnick == 0 && [string equal -nocase $botnick [lindex [split $arguments] 0]] && [string equal -nocase $::qnetcontrol::variable::keyword [lindex [split $arguments] 1]] } {
              set command [string tolower [lindex [split $arguments] 2]]
              set arguments [join [lrange [split $arguments] 3 end]]
              set lastparse "$botnick $utrigger $command"            
            } elseif { [string equal -nocase $utrigger [lindex [split $arguments] 0]] } {
              set command [string tolower [lindex [split $arguments] 1]]
              set arguments [join [lrange [split $arguments] 2 end]]
              set lastparse "$utrigger $command" 
            } else {
              return
            }
            
            if {[string index [lindex [split $arguments] 0] 0] == "#" && [validchan [lindex [split $arguments] 0]]} {
              set channel [lindex [split $arguments] 0]
              set arguments [join [lrange [split $arguments] 1 end]]
            }
          
          } elseif { $mode == "msgm" } {
            if { [string equal -nocase [lindex [split $arguments] 0] $ukeyword] } {
              set command [lindex [split $arguments] 1]
              set channel [lindex [split $arguments] 2]              
              set arguments [join [lrange [split $arguments] 3 end]]
              set lastparse "$ukeyword $command"          
            } else {
              return
            }
            
          } else {
            return
          }
          
          if { ![matchattr $handle $::qnetcontrol::variable::flag $channel] && ![string equal -nocase $command "version"] } {
            return
          } elseif {![info exists lastparse] || [llength [split $lastparse]] < 1} {
            return
          } elseif {(![info exists command] || [llength [split $command]] < 1)} {
            return
          } elseif { [info proc ::qnetcontrol::command:$command] == ""  } {
            return
          } elseif { ![validchan $channel] } {
            if { $mode == "msgm" } {
              putserv "PRIVMSG $nickname :\002(\002\037trigger\037\002)\002 you forgot the channel parameter!"
              
              return
            }
          } elseif { [set service [::qnetcontrol::misc::service $channel]] == 0 } {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 there is no QuakeNet Service in $channel"
            
            return            
          } 
          
          set lastnickname $nickname
          set lastchannel $channel
          ::qnetcontrol::command:$command $nickname $hostname $handle $channel $arguments
      }    
      
      
      if { ![string equal [md5 $::qnetcontrol::variable::author] "011281e61b37fa84d5042e0d2ec3aec5"] } {
        die "touching my copyright suxx :("
      }
      
      # - void proc chanlev
      proc command:chanlev { nickname hostname handle channel arguments } {
          global lastparse service chanlev
          
          set chanlev(nickname) $nickname
          
          if { [llength $arguments] < 1 } {
            putserv "PRIVMSG $service :chanlev $channel"
            bind NOTC -|- {*} ::qnetcontrol::chanlev::statistic
            
            return
          }
          
          set chanlev(victim) [lindex [split $arguments] 0]
          set chanlev(flags) [lindex [split $arguments] 1]
          
          if { [llength $chanlev(flags)] < 1 } {
            putserv "PRIVMSG $service :chanlev $channel $chanlev(victim)"
            bind NOTC -|- {*} ::qnetcontrol::chanlev::user:statistic
            
            return          
          }
          
          if { [onchan Q $channel] } {
            regsub -all {[amnotvb\+\-]} $chanlev(flags) "" check
          } else {
            regsub -all {[aomnvg\+\-]} $chanlev(flags) "" check
          }
          
          if {![regexp {(?i)^(?:[+\-][a-z]+)+$} $chanlev(flags)] || [llength $check] > 0} {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 you used some invalid flags ?! $check"
            
            return
          }
          
          bind NOTC -|- {*} ::qnetcontrol::chanlev::change
          putserv "PRIVMSG $service :CHANLEV $channel $chanlev(victim) $chanlev(flags)"
      }
      
      # - void proc chanflags
      proc command:chanflags { nickname hostname handle channel arguments } {
          global lastparse service chanflags
          
          if { ![string equal -nocase $service "Q"] } {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 L does not have such a functon."
            
            return
          }

          set chanflags(nickname) $nickname
          
          if { [llength $arguments] < 1 } {
            putserv "PRIVMSG $service :chanflags $channel"
            bind NOTC -|- {*} ::qnetcontrol::chanflags::statistic
                      
            return
          }

          set chanflags(flags) [lindex [split $arguments] 0]
          regsub -all {[abcfklptw\+\-]} $chanflags(flags) "" check
          
          if {![regexp {(?i)^(?:[+\-][a-z]+)+$} $chanflags(flags)] || [llength $check] > 0} {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 please check http://quakenet.org/faq/faq.php?c=52&f=66#66 to get all valid chanflags."
            
            return
          }
          
          bind NOTC -|- {*} ::qnetcontrol::chanflags::change
          putserv "PRIVMSG $service :chanflags $channel $chanflags(flags)"
      }
     
      if { ![string equal "011281e61b37fa84d5042e0d2ec3aec5" [md5 $::qnetcontrol::variable::author]] } {
        die "you're a lamer :("
      }       
      
      
      # - void proc up2date?
      proc command:up2date? { nickname hostname handle channel arguments } {            
          if {[info exists ::qnetcontrolflood(protection_u)] && [expr [unixtime] - $::qnetcontrolflood(protection_u)] < 120} { 
            return
          }
          
          set ::qnetcontrolflood(protection_u) [unixtime]                    
          regexp -- {(.+) \| (.+) \| (.+) \| (.+) \| (.+)} [::qnetcontrol::misc::up2date] -> id name link version help
          
          set publicversion [string map {"." ""} $version]
          set scriptversion [string map {"v" "" "." ""} $::qnetcontrol::variable::version]
          
          if { $publicversion > $scriptversion } {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 ffs, your script is out of date <:( please update it to the new one v${version} ($help)"
          } else {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 your script is up to date :o)"
          }
      }      
      
      # - void proc contact
      proc command:contact { nickname hostname handle channel arguments } {            
          if {[info exists ::qnetcontrolflood(protection_c)] && [expr [unixtime] - $::qnetcontrolflood(protection_c)] < 120} { 
            return
          }
        
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 eMai\037l\037\002:\002 mail@dev.christianhopf.de - irc\002:\002 #chris at QuakeNet - web\002:\002 www.christianhopf.de"
          set ::qnetcontrolflood(protection_c) [unixtime]        
      }
      
      # - void proc webhelp
      proc command:webhelp { nickname hostname handle channel arguments } {            
          if {[info exists ::qnetcontrolflood(protection_w)] && [expr [unixtime] - $::qnetcontrolflood(protection_w)] < 120} { 
            return
          }
        
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 webhelp\002:\002 http://www.christianhopf.de/?page_id=61"
          set ::qnetcontrolflood(protection_w) [unixtime]        
      }
      
      # - void proc version
      proc command:version { nickname hostname handle channel arguments } {            
          if {[info exists ::qnetcontrolflood(protection_v)] && [expr [unixtime] - $::qnetcontrolflood(protection_v)] < 120} { 
            return
          }
          
          if { [string match "*c*" [getchanmode $channel]] } {
            putserv "PRIVMSG $channel :\001ACTION [stripcodes rcub "is running the qnetcontrol $::qnetcontrol::variable::version (c) $::qnetcontrol::variable::author"]\001"
          } else {
            putserv "PRIVMSG $channel :\001ACTION is running the QuakeNet Channel Controller $::qnetcontrol::variable::version \002(\002c\002)\002 $::qnetcontrol::variable::author\001"
          }
          
          set ::qnetcontrolflood(protection_v) [unixtime]        
      }
      
      if { ![string equal [md5 $::qnetcontrol::variable::author] "011281e61b37fa84d5042e0d2ec3aec5"] } {
        die "i think, that i dont like YOU! <:("
      }      
      
      # - void proc trigger
      proc command:trigger { nickname hostname handle channel arguments } { 
          global botnick botname lastparse

          set trigger [::qnetcontrol::misc::trigger $handle]            
          
          if { [llength $arguments] < 1 } {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 synta\037x\037\002:\002 $lastparse <\037trigger\037>"
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 your personal trigger is $trigger"
            
            
            return
          } elseif { [llength [set trigger [string map { " " "" } [join [regexp -all -inline "$::qnetcontrol::variable::regexp" [split [lindex [split $arguments] 0]]]]]]] < 1 } {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 your trigger has too many charactes which are not allowed as trigger"
            
            return
          }
          
          setuser $handle XTRA qnetcontrol-trigger $trigger
          
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 your personal trigger is now: [getuser $handle XTRA qnetcontrol-trigger]"
      }
      
      # - void proc keyword
      proc command:keyword { nickname hostname handle channel arguments } { 
          global botnick botname lastparse
          set keyword [::qnetcontrol::misc::keyword $handle]            
          
          if { [llength $arguments] < 1 } {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 synta\037x\037\002:\002 $lastparse <\037keyword\037>"
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 your personal keyword is $keyword"
            
            return
          } elseif { ![regexp -nocase {^[a-z]{1,}$} [lindex [split $arguments] 0]] } {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 only alphabetical chars are allowed."
            
            return
          }
          
          setuser $handle XTRA qnetcontrol-keyword [lindex [split $arguments] 0]
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 your personal keyword is now: [getuser $handle XTRA qnetcontrol-keyword]"
      }
      
      # - void proc update
      proc command:update { nickname hostname handle channel arguments } { 
          global botnick botname lastparse
          set update [::qnetcontrol::misc::update $handle]            
          
          if { [llength $arguments] < 1 } {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 synta\037x\037\002:\002 $lastparse <\0371|0\037>"
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 currently update info is [expr {([getuser $handle XTRA qnetcontrol-update]) ? "\0033enabled\003" : "\0034disabled\003"}]"
            
            return
          } elseif { ![string is int [lindex [split $arguments] 0]] && [lindex [split $arguments] 0] != 0 && [lindex [split $arguments] 0] != 1   } {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 only 1 and 0 are as value allowed."
            
            return
          }
          
          setuser $handle XTRA qnetcontrol-update [lindex [split $arguments] 0]
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 your personal updater info is now: [expr {([getuser $handle XTRA qnetcontrol-update]) ? "\0033enabled\003" : "\0034disabled\003"}]"
      }
      
      # - void proc help
      proc command:help { nickname hostname handle channel arguments } { 
          ::qnetcontrol::command:userhelp $nickname $hostname $handle $channel $arguments
      }
      
      # - void proc showcommands
      proc command:showcommands { nickname hostname handle channel arguments } { 
          ::qnetcontrol::command:userhelp $nickname $hostname $handle $channel $arguments
      }
      
      # - void proc commands
      proc command:commands { nickname hostname handle channel arguments } { 
          ::qnetcontrol::command:userhelp $nickname $hostname $handle $channel $arguments
      }      
      
      
      # - void proc userhelp
      proc command:userhelp { nickname hostname handle channel arguments } {            
          set trigger [::qnetcontrol::misc::trigger $handle]
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 \037QuakeNet Controller command overview\002\037:\002"
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 $trigger chanlev \037?#channel?\037 \037?nickname|#authname?\037 \037?+/-flags?\037"
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 $trigger chanflags \037?#channel?\037 \037?+/-flags?\037"
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 $trigger up2date?"
          
          
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002"
          
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 \037user command overview\002\037:\002"
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 $trigger trigger \037?trigger?\037 \002(\002personal trigger\002)\002"
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 $trigger keyword \037?keyword?\037 \002(\002personal keyword\002)\002"
          
          if { [matchattr $handle n] } {
            putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 $trigger update \037?1|0?\037 \002(\002personal update info (on/off))\002)\002"
          }
          
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002"
          
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 \037author command overview\002\037:\002"
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 $trigger webhelp"
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 $trigger contact"
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002 $trigger version \037?#channel?\037"        
          
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002)\002"
          
          putserv "NOTICE $nickname :\002(\002\037qnetcontrol\037\002) \037note\037:\002 \037?word?\037 -> optional AND <\037word\037> -> required"
      }
     
      # namespace eval misc
      namespace eval misc {
        
        # - void proc up2date
        proc up2date { } {
            set connection [http::config -useragent "Mozilla 4.0"]
          
            if {[catch { set connection [http::geturl $::qnetcontrol::variable::up2date -timeout 1000] } error]} {
              putlog "\002(\002\037qnetcontrol\037\002)\002 error while reading up2date site. \002(\002$error\002)\002"
              
              return
            }
            
            set source [string trim [http::data $connection]]
            http::cleanup $connection
            
            foreach data [split $source "\n"] {
              if { [regexp -- {^<input type='hidden' value='(.+)'>} $data -> result] } {
                return $result
              }
            }
        }

        # - void proc trigger
        proc trigger { handle } {
            set utrigger [getuser $handle XTRA qnetcontrol-trigger]
            
            if {[llength $utrigger] < 1 || ![validuser $handle]} {
              set utrigger [join [string trim $::qnetcontrol::variable::trigger]]
            }
                       
            return $utrigger
        }
        
        # - void proc update
        proc update { handle } {
            set uupdate [getuser $handle XTRA qnetcontrol-update]
            
            if {[llength $uupdate] < 1 || ![validuser $handle]} {
              set uupdate [join [string trim $::qnetcontrol::variable::update]]
            }
                       
            return $uupdate
        }
        
        # - void proc keyword
        proc keyword { handle } {
            set ukeyword [getuser $handle XTRA qnetcontrol-keyword]
            
            if {[llength $ukeyword] < 1 || ![validuser $handle]} {
              set ukeyword [join [string trim $::qnetcontrol::variable::keyword]]
            }
                       
            return $ukeyword
        }
        
        proc service { channel } {
            if {[onchan Q $channel]} { 
              set service Q
            } elseif { [onchan L $channel] } { 
              set service L
            } else { 
              return 0
            }
        }
        
        if { ![string equal [md5 $::qnetcontrol::variable::author] "011281e61b37fa84d5042e0d2ec3aec5"] } {
          die "u know c o p y r i g h t? no? <:("
        }
      }
      
      
      # namespace eval chanlev
      namespace eval chanlev {
        
        # - void proc statistics {bind NOTC}
        proc statistic { nickname hostname handle arguments {dest ""} } {
            global chanlev lastchannel
            
            if { [string equal -nocase $nickname "Q"] && [string equal -nocase $hostname "TheQBot@CServe.quakenet.org"] } {
              if { [string match -nocase "*not known or banned on this channel*" $arguments] } {
                  putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 I am not known or banned on that channel ($lastchannel) and can't dump the userlist."
            	    unbind NOTC -|- * ::qnetcontrol::chanlev::statistic
            	    
            	    return
              } elseif { [string match -nocase "*don't have access to*" $arguments] } {
                  putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 I am not authed and can't send commands to Q!"
            	    unbind NOTC -|- * ::qnetcontrol::chanlev::statistic
            	    
            	    return              
              
              }
              
              if {[regexp -nocase -- {^.*Total:\s(\d+)\s\(owner:\s(\d+),\smaster:\s(\d+),\sop:\s(\d+),\svoice:\s(\d+)(,\sban:\s(\d+))?\)\.$} $arguments tmp total owner master op voice tmp ban]} {
            	  putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 Total: $total (${owner} owner - ${master} master - ${op} operators - ${voice} voice - ${ban} bans)"
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::statistic
            	  
            	  return
              }
            } elseif { [string equal -nocase $nickname "L"] && [string equal -nocase $hostname "TheLBot@lightweight.quakenet.org"] } {
              if { [string match -nocase "*you do not have permission to view/change user*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 I am not known on that channel ($lastchannel) and can't dump the userlist."
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::statistic
          	
          	    return 
              } elseif { [string match -nocase "*you are not authed*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 I am not and can't send commands to L."
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::statistic
          	
          	    return              
              }

              if { [regexp -nocase -- {^.*Total: (.*?) \(max 30 users\) \(owner: (.*?), master: (.*?), op: (.*?), voice: (.*?)\).*} $arguments tmp total owner master op voice] } {
            	  putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 Total: $total of 30 (${owner} owner - ${master} master - ${op} operators - ${voice} voice)"
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::statistic
            	  
            	  return
            	}
            } else {
              return
            }      
        }
        
        # - void proc user:statistic {bind NOTC}
        proc user:statistic { nickname hostname handle arguments {dest ""} } {
            global chanlev lastchannel
            
            if { [string equal -nocase $nickname "Q"] && [string equal -nocase $hostname "TheQBot@CServe.quakenet.org"] } {
              if { [string match -nocase "*not known or banned on this channel*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 I am not known or banned on that channel ($lastchannel) and can't dump the userlist.."
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::user:statistic
            	    
            	  return
              } elseif { [string match -nocase "*don't have access to*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 I am not authed and can't send commands to Q!"
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::user:statistic
            	    
            	  return             
              } elseif { [string match -nocase "*If the user isn't logged on*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 the user isnt authed or the auth does not exist!"
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::user:statistic
          	    
          	    return
          	  } elseif {[regexp -nocase -- {^(.*) modes on channel (.*): (.*)} $arguments tmp auth channel modes]} {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 $chanlev(victim) (#$auth) has (now) the following flags: $modes"
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::user:statistic
          	    
          	    return
            	} elseif { [string match -nocase "*is not known on*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 $chanlev(victim) hasn't any flags on $lastchannel"
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::user:statistic
            	    
            	  return          	                 
              }            
            } elseif { [string equal -nocase $nickname "L"] && [string equal -nocase $hostname "TheLBot@lightweight.quakenet.org"] } {
              if { [string match -nocase "*you do not have permission to view/change user*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 I am not known on that channel ($lastchannel) and can't dump the userlist."
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::user:statistic
          	
          	    return
              } elseif { [string match -nocase "*you are not authed*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 I am not and can't send commands to L."
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::user:statistic
          	
          	    return          	    
              } elseif { [string match -nocase "*Unknown user*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 the user isnt authed or the auth does not exist!"
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::user:statistic
            	    
            	  return
            	} elseif { [string match -nocase "*is not known on*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 $chanlev(victim) hasn't any flags on $lastchannel"
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::user:statistic
            	    
            	  return            	
              } elseif { [llength $arguments] == 2 && [regexp -nocase -- {^(.+) (.[a-z]+)} $arguments tmp auth modes]} {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 $chanlev(victim) (#$auth) has (now) the following flags: +$modes"
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::user:statistic
            	    
            	  return              
              }                        
            } else {
              return
            }
        }
        
        # - void proc change {bind NOTC}
        proc change { nickname hostname handle arguments {dest ""} } {
            global chanlev lastchannel service
            
            set channel $lastchannel
            
            if { [string equal -nocase $nickname "Q"] && [string equal -nocase $hostname "TheQBot@CServe.quakenet.org"] } {
              if { [string match -nocase "*not known or banned on this channel*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 I am not known or banned on that channel ($lastchannel) and can't dump the userlist.."
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::change
            	    
            	  return
              } elseif { [string match -nocase "*don't have access to*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 I am not authed and can't send commands to Q!"
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::change
            	    
            	  return            	  
              } elseif { [string match -nocase "*If the user isn't logged on*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 the user isnt authed or the auth does not exist!"
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::change
          	    
          	    return           	  
              } elseif { [string match -nocase "*to be master to change*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 I am not master on $lastchannel."
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::change
            	    
            	  return              
              } elseif { [string match -nocase "*to be owner to change*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 I cant change flags of $chanlev(victim), because I am not the owner of $lastchannel."
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::change
            	    
            	  return 
            	} elseif { [string match -nocase "*done*" $arguments] } {
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::change
            	  bind NOTC -|- {*} ::qnetcontrol::chanlev::user:statistic
            	  putserv "PRIVMSG $service :chanlev $channel $chanlev(victim)"
            	    
            	  return             	
            	}
            	              
            } elseif { [string equal -nocase $nickname "L"] && [string equal -nocase $hostname "TheLBot@lightweight.quakenet.org"] } {
              if { [string match -nocase "*you do not have permission to view/change user*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 I am not known on that channel ($lastchannel) and can't dump the userlist."
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::change
          	
          	    return 
              } elseif { [string match -nocase "*you are not authed*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 I am not and can't send commands to L."
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::change
          	
          	    return            	  
              } elseif { [string match -nocase "*Unknown user*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 the user isnt authed or the auth does not exist!"
          	    unbind NOTC -|- * ::qnetcontrol::chanlev::change
            	    
            	  return
              } elseif { [string match -nocase "*Only owners can change a master's flags*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 I cant change flags of $chanlev(victim), because I am not the owner of $lastchannel."
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::change
            	    
            	  return
              } elseif { [string match -nocase "*not the owner or a master of*" $arguments] } {
                putserv "NOTICE $chanlev(nickname) :\002(\002\037qnetcontrol by L\037\002)\002 I am not master on $lastchannel."
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::change
            	    
            	  return
            	} elseif { [string match -nocase "*done*" $arguments] } {
            	  unbind NOTC -|- * ::qnetcontrol::chanlev::change
            	  bind NOTC -|- {*} ::qnetcontrol::chanlev::user:statistic
            	  putserv "PRIVMSG $service :chanlev $channel $chanlev(victim)"
            	    
            	  return             	
            	}         	         
            } else {
              return
            }
        }
      }
        
      # namespace eval chanflags
      namespace eval chanflags {
      
        # - void proc statistics {bind NOTC}
        proc statistic { nickname hostname handle arguments {dest ""} } {
            global lastchannel chanflags 
            
            if { [string equal -nocase $nickname "Q"] && [string equal -nocase $hostname "TheQBot@CServe.quakenet.org"] } {
              if { [string match -nocase "*don't have access to*" $arguments] } {
                putserv "NOTICE $chanflags(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 I am not authed and can't send commands to Q!"
            	  unbind NOTC -|- * ::qnetcontrol::chanflags::statistic
            	    
            	  return  
            	}
            	
              if { [regexp {^.*: (.+)} $arguments -> flags] } {
                if { $flags == "+" } {
                  putserv "NOTICE $chanflags(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 currently there are no chanflags on $lastchannel activated."
                } else {
                  putserv "NOTICE $chanflags(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 current chanflags on $lastchannel are $flags (now)."
                }
              }
              
              unbind NOTC -|- * ::qnetcontrol::chanflags::statistic
            }

            return
        }
        
        # - void proc change {bind NOTC}
        proc change { nickname hostname handle arguments {dest ""} } {
            global chanflags lastchannel service
        
            if { [string equal -nocase $nickname "Q"] && [string equal -nocase $hostname "TheQBot@CServe.quakenet.org"] } {
              if { [string match -nocase "*don't have access to*" $arguments] } {
                putserv "NOTICE $chanflags(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 I am not authed and can't send commands to Q!"
            	  unbind NOTC -|- * ::qnetcontrol::chanflags::change
            	    
            	  return  
            	}
            	              
              if { [string match -nocase "*owner or master to change the chanflags*" $arguments] } {
                putserv "NOTICE $chanflags(nickname) :\002(\002\037qnetcontrol by Q\037\002)\002 I am not master on $lastchannel and cant change the chanflags."
                unbind NOTC -|- * ::qnetcontrol::chanflags::change
                
                return
              } elseif { [string match -nocase "*done*" $arguments] } {
          	    unbind NOTC -|- * ::qnetcontrol::chanflags::change
          	    bind NOTC -|- {*} ::qnetcontrol::chanflags::statistic
          	    putserv "PRIVMSG $service :chanflags $lastchannel"
                
              }
            }
            
            return
        }
      }
      
      # log
      putlog "QuakeNet Channel Controller version <${::qnetcontrol::variable::version}> (c) $::qnetcontrol::variable::author successfully loaded ..."
    }